Index: channels/chan_sip.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_sip.c,v
retrieving revision 1.576
diff -u -r1.576 chan_sip.c
--- channels/chan_sip.c	25 Nov 2004 22:11:06 -0000	1.576
+++ channels/chan_sip.c	27 Nov 2004 15:48:21 -0000
@@ -7079,7 +7079,7 @@
 		ast_quiet_chan(peera);
 		ast_quiet_chan(peerb);
 		ast_quiet_chan(peerc);
-		ast_quiet_chan(peerd);
+
 
 		if (peera->cdr && peerb->cdr) {
 			peerb->cdr = ast_cdr_append(peerb->cdr, peera->cdr);
@@ -7098,6 +7098,11 @@
 		if (ast_channel_masquerade(peerb, peerc)) {
 			ast_log(LOG_WARNING, "Failed to masquerade %s into %s\n", peerb->name, peerc->name);
 			res = -1;
+		} else {
+			if (peera)
+				ast_softhangup_nolock(peera, AST_SOFTHANGUP_DEV);
+			if (peerd)
+				ast_softhangup_nolock(peerd, AST_SOFTHANGUP_DEV);
 		}
 		return res;
 	} else {
